#!/usr/bin/env python
# *********************************************************************
# * Copyright (C) 2012--2013 Luca Baldini (luca.baldini@pi.infn.it)   *
# *                                                                   *
# * For the license terms see the file LICENCE, distributed           *
# * along with this software.                                         *
# *********************************************************************
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.


import logging
import sys

logger = logging.getLogger('resample')
logger.setLevel(logging.DEBUG)

# Terminal setting.
consoleHandler = logging.StreamHandler()
consoleHandler.setLevel(logging.DEBUG)
consoleFormatter = logging.Formatter(">>> %(message)s")
consoleHandler.setFormatter(consoleFormatter)
logger.addHandler(consoleHandler)

def abort(message = ''):
    """ Abort the execution.
    """
    if message != '':
        message = '%s. Abort.' % message
    else:
        message = 'Abort.'
    sys.exit(message)


def startmsg():
    """ Print the start message.
    """
    from __version__ import TAG, BUILD_DATE
    print('\n    Welcome to eee version %s (built on %s).\n' %\
              (TAG, BUILD_DATE))
    print('    Copyright (C) 2012--2013 Luca Baldini '
          '(luca.baldini@pi.infn.it)\n\n'
          '    eee comes with ABSOLUTELY NO WARRANTY.\n'
          '    This is free software, and you are welcome to redistribute '
          'it under certain\n'
          '    conditions. See the LICENSE file for details.\n\n'
          '    Visit https://bitbucket.org/lbaldini/eee/wiki/Home for '
          'more information.\n')
