/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3BaseEvent.h"


E3BaseEvent::E3BaseEvent() :
  m_stationId(-1),
  m_runId(-1),
  m_eventId(-1),
  m_timestamp(E3Timestamp(-1, 0)),
  m_statusMask(E3BitMask()),
  m_errorMask(E3BitMask())
{}


E3BaseEvent::E3BaseEvent(E3::Station_t stationId, E3::Run_t runId,
                         E3::Event_t eventId, E3Timestamp timestamp) :
  m_stationId(stationId),
  m_runId(runId),
  m_eventId(eventId),
  m_timestamp(timestamp),
  m_statusMask(E3BitMask()),
  m_errorMask(E3BitMask())
{}


std::ostream& E3BaseEvent::fillStream(std::ostream& os) const
{
  os << "Station ID = " << m_stationId << ", run ID = "
     << m_runId << ", event number = " << m_eventId << ", timestamp = "
     << m_timestamp;
  return os;
}
