/*
  Copyright (C) 2013 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#include "E3BitMask.h"


E3BitMask::E3BitMask() :
  m_payload(0)
{}


std::ostream& E3BitMask::fillStream(std::ostream& os) const
{
  for (unsigned int i = 8*sizeof(m_payload) - 1; i != 0 ; i--) {
    if (i % 8 == 0) os << ".";
    else os << " ";
  }
  os << ".\n";
  os << std::bitset<8*sizeof(m_payload)>(m_payload);
  return os;
}
