/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef E3Chrono_H
#define E3Chrono_H

#include <ctime>


/*! \class E3Chrono
  \brief Small class for simple profiling of the code.
*/

class E3Chrono
{
 public:
  /// \brief Default constructor.
  E3Chrono() { start(); }
  
  /// \brief Destructor.
  ~E3Chrono() {}

  /// \brief Start the chrono.
  inline void start() { m_start = clock(); }

  /// \brief Stop the crono and return the elapsed time.
  inline double stop() { return double(clock() - m_start)/CLOCKS_PER_SEC;}

 private:
  /// \brief The underlying clock_t object filled at start time. 
  clock_t m_start;
};

#endif
