/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3DigiWord.h"


E3DigiWord::E3DigiWord(E3::DigiWord_t payload) :
  m_payload(payload)
{}


E3::Channel_t E3DigiWord::channel() const
{
  E3::Channel_t channel = (m_payload >> 19) & 0x1f;
  if (channel < 8) channel = 7 - channel;
  else if (channel < 16) channel = 23 - channel;
  else if (channel < 24) channel = 39 - channel;
  return channel;
}


std::ostream& E3DigiWord::fillStream(std::ostream& os) const
{
  os << "digi word " << std::hex << std::showbase << m_payload
     << std::noshowbase << std::dec;
  return os;
}
