/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#include "E3MessageLogger.h"


E3MessageLogger::E3MessageLogger()
{
  // Nothing to do.
}


std::ostringstream& E3MessageLogger::get(LoggingLevel level)
{
  //m_outputStream << ">>> ";
  switch (level) {
  case DEBUG:
    m_outputStream << "[DEBUG]: ";
    break;
  case INFO:
    m_outputStream << "[INFO] : ";
    break;
  case WARNING:
    m_outputStream << "[WARN] : ";
    break;
  case ERROR:
    m_outputStream << "[ERROR]: ";
    break;
  default:
    break;
  }
  m_currentMsgLevel = level;
  return m_outputStream;
}


E3MessageLogger::~E3MessageLogger()
{
  // if (m_currentMsgLevel >= LOGGING_LEVEL) {
  m_outputStream << std::endl;
  fprintf(stderr, "%s", m_outputStream.str().c_str());
  fflush(stderr);
  //}
}
