/*
  Copyright (C) 2013 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#include "E3MinimalNtuple.h"


E3MinimalNtuple::E3MinimalNtuple() :
  E3TextNtuple("MinimalTuple")
{}


E3MinimalNtuple::E3MinimalNtuple(std::string label) :
  E3TextNtuple(label)
{}


void E3MinimalNtuple::addColumns()
{
  addColumn("StationId", 'I');
  addColumn("RunId", 'I');
  addColumn("EventId", 'I');
  addColumn("Seconds", 'I');
  addColumn("Nanoseconds", 'I');
  addColumn("StatusCode", 'I');
  addColumn("ErrorCode", 'I');
}


void E3MinimalNtuple::writeRow(const E3BaseEvent &event, bool eol)
{
  write(event.stationId(), 5);
  write(event.runId(), 8);
  write(event.eventId(), 12);
  write(event.seconds(), 15);
  write(event.nanoseconds(), 12);
  write(event.statusMask().payload(), 10);
  write(event.errorMask().payload(), 10);
  if (eol) endline();
}
