/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef E3RandomGaussGenerator_H
#define E3RandomGaussGenerator_H

#include "E3RandomGenerator.h"


/*! \class E3RandomGaussGenerator
  \brief Class for generating gaussian random numbers.
*/

class E3RandomGaussGenerator : public E3RandomGenerator
{
 public:
  /// \brief Default constructor.
  E3RandomGaussGenerator(double mean, double sigma, int seed);

  /// \brief Destructor.
  ~E3RandomGaussGenerator() {}

  /// \brief Sample the distribution.
  double sample();

 protected:
  std::normal_distribution<double> m_distribution;
};

#endif
