/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3RandomTimeGenerator.h"


E3RandomTimeGenerator::E3RandomTimeGenerator(double rate, int seed) :
  E3RandomGenerator(seed),
  m_previousTime(0.)
{
  m_distribution = std::exponential_distribution<double>(rate);
}


E3RandomTimeGenerator::E3RandomTimeGenerator(double rate, double startTime,
                                             int seed) :
  E3RandomGenerator(seed),
  m_previousTime(startTime)
{
  m_distribution = std::exponential_distribution<double>(rate);
}


double E3RandomTimeGenerator::time()
{
  m_previousTime += m_distribution(m_generator);
  return m_previousTime;
}


E3Timestamp E3RandomTimeGenerator::timestamp()
{
  return E3Timestamp(time());
}

