/*
  Copyright (C) 2012--2013 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3RunInfo.h"


E3RunInfo::E3RunInfo(E3::Version_t versionNumber, E3::Station_t stationId,
                     E3::Run_t runId, std::string runName,
                     E3::TriggerMask_t triggerMask, E3NinoMap ninoMap,
                     E3GpsRecord startRunGpsRecord) :
  m_versionNumber(versionNumber),
  m_stationId(stationId),
  m_runId(runId),
  m_runName(runName),
  m_triggerMask(triggerMask),
  m_ninoMap(ninoMap),
  m_startRunGpsRecord(startRunGpsRecord)
{}


std::ostream& E3RunInfo::fillStream(std::ostream& os) const
{
  os << "=================================== " 
     << "Run Info"
     << " ===================================" << std::endl
     << "Header version number: " << m_versionNumber << std::endl
     << "Station Id...........: " << m_stationId << std::endl
     << "Run Id...............: " << m_runId << std::endl
     << "Trigger mask.........: " << m_triggerMask << std::endl
     << "Nino Map.............: " << m_ninoMap << std::endl
     << "Start run GPS record.: " << m_startRunGpsRecord << std::endl
     << "========================================"
     << "========================================";
  return os;
}
