/*
  Copyright (C) 2013 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/


#include "E3TerminalFormatting.h"



void E3TerminalFormatting::startmsg()
{
  std::cout << "\n    Welcome to eee version " << __version__ << " (built on "
            << __builddate__ << ").\n"
            << "\n    Copyright (C) 2012--2013 Luca Baldini "
            << "(luca.baldini@pi.infn.it)\n\n"
            << "    eee comes with ABSOLUTELY NO WARRANTY.\n"
            << "    This is free software, and you are welcome to redistribute "
            << "it under certain\n"
            << "    conditions. See the LICENSE file for details.\n\n"
            << "    Visit https://bitbucket.org/lbaldini/eee/wiki/Home for "
            << "more information.\n\n";
}


std::string E3TerminalFormatting::hline(bool eol)
{
  std::stringstream s("");
  for (unsigned int i = 0; i < E3TerminalFormatting::kTerminalWidth; i++) {
    s << E3TerminalFormatting::kHorLineChar;
  }
  if (eol) s << E3TerminalFormatting::kEolChar;
  return s.str();
}


std::string E3TerminalFormatting::title(std::string text, bool eol)
{
  std::stringstream s("");
  const unsigned int wl = (E3TerminalFormatting::kTerminalWidth -
                           text.size() -
                           2*E3TerminalFormatting::kTitlePadding)/2;
  const unsigned int wr = E3TerminalFormatting::kTerminalWidth - 
    text.size() - 2*E3TerminalFormatting::kTitlePadding - wl;
  for (unsigned int i = 0; i < wl; i++) {
    s << E3TerminalFormatting::kHorLineChar;
  }
  for (unsigned int i = 0; i < E3TerminalFormatting::kTitlePadding; i++) {
    s << " ";
  }
  s << text;
  for (unsigned int i = 0; i < E3TerminalFormatting::kTitlePadding; i++) {
    s << " ";
  }
  for (unsigned int i = 0; i < wr; i++) {
    s << E3TerminalFormatting::kHorLineChar;
  }
  if (eol) s << E3TerminalFormatting::kEolChar;
  return s.str();
}
