/*
  Copyright (C) 2013 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef E3TextOutputFile_H
#define E3TextOutputFile_H

#include <iostream>
#include <fstream>

#include "E3MessageLogger.h"
#include "E3StatusCode.h"


/*! \class E3TextOutputFile
  \brief Utility class describing an output ascii stream.

  \todo Is it a bad idea to inherit from std::ifstream? We should reconsider
  whether composition would be a better idea (or getting rid of this class
  altogether).
*/

class E3TextOutputFile : public std::ofstream
{
 public:
  /// \brief Default constructor.
  E3TextOutputFile();

  /// \brief Destructor.
  ~E3TextOutputFile() {}

  /// \brief Open the output stream in ascii mode.
  StatusCode open(const char* filePath);

  /// \brief Open the output stream in ascii mode.
  StatusCode open(const std::string filePath);
};

#endif
