/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#ifndef E3TriggerMask_H
#define E3TriggerMask_H

#include <iostream>

#include "E3.h"


/*! \class E3TriggerMask
  \brief .
*/

class E3TriggerMask
{
 public:
  /// \brief Default constructor.
  E3TriggerMask(E3::TriggerMask_t payload);

  /// \brief Destructor.
  ~E3TriggerMask() {}

  /// \brief Standard output.
  std::ostream& fillStream(std::ostream& os) const;

  /// \brief Standard output.
  friend std::ostream& operator<<(std::ostream& os, const E3TriggerMask& m)
  { return m.fillStream(os); }

 private:
  /// \brief The underlying bit mask.
  E3::TriggerMask_t m_payload;
};

#endif
