/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3Point.h"
#include "E3Vector.h"


int main () {
  E3Point p1(1., 1., 1.);
  E3Point p2(1., 2., 3.);
  std::cout << "p1 = " << p1 << std::endl;
  std::cout << "p2 = " << p2 << std::endl;
  std::cout << "p1 + p2 = " << p1 + p2 << std::endl;
  std::cout << "p1*2. = " << p1*2. << std::endl;
  std::cout << "2.*p1 = " << 2.*p1 << std::endl;
  std::cout << "p1/2 = " << p1/2 << std::endl;
  std::cout << "p1/0 = " << p1/0 << std::endl;
  E3Vector v1;
  E3Vector v2(1, 0, 0);
  E3Vector v3(1, 1, 0);
  E3Vector v4(0, 1, 0);
  std::cout << "v1 = " << v1 << std::endl;
  std::cout << "v2 = " << v2 << std::endl;
  std::cout << "v3 = " << v3 << std::endl;
  std::cout << "v4 = " << v3 << std::endl;
  std::cout << "v1.mag() = " << v1.mag() << std::endl;
  std::cout << "v2.mag() = " << v2.mag() << std::endl;
  std::cout << "v3.mag() = " << v3.mag() << std::endl;
  std::cout << "v3/2. = " << v3/2. << std::endl;
  std::cout << "v3.unit() = " << v3.unit() << std::endl;
  std::cout << v2.theta() << " " << v2.phi() << std::endl;
  std::cout << v3.theta() << " " << v3.phi() << std::endl;
  std::cout << "dot(v2, v3) = " << dot(v2, v3) << std::endl;
  std::cout << "dot(v2, v4) = " << dot(v2, v4) << std::endl;
  std::cout << "cross(v2, v3) = " << cross(v2, v3) << std::endl;
  std::cout << "cross(v2, v4) = " << cross(v2, v4) << std::endl;
  std::cout << "angle(v2, v3) = " << angle(v2, v3) << std::endl;
  std::cout << "angle(v2, v4) = " << angle(v2, v4) << std::endl;
  return 0;
}
