/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3OptionParser.h"
#include "E3Variant.h"


int main (int argc, char* argv[]) {
  std::string intent = "Just a dummy test parser";
  std::string usage = "test_optparse [options] file.dat";
  E3OptionParser parser(intent, usage);
  parser.addOption<int>("num-events", 'n', 100,
                        "Number of events to be processed");
  parser.addOption<double>("test-double", 'd', 1.,
                           "Test double option");
  parser.addOption<bool>("test-bool", 'b', "Test bool option");
  parser.addOption<std::string>("test-string", 's', "Test string option", true);
  parser.parse(argc, argv);
  if (parser.numArguments() != 1) {
    parser.parseError("Please provide exactly one input file.");
  }
  std::string firstArg = parser.getArguments().front();  
  std::cout << parser << std::endl;
  std::cout << "First argument: " << firstArg << std::endl;
  return 0;
}
