/*
  Copyright (C) 2012 Luca Baldini (luca.baldini@pi.infn.it)

  For the license terms see the file LICENSE, distributed along with this
  software.

  This program is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation; either version 3 of the License, or (at your option) any later
  version.
  
  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License along with
  this program; if not, write to the Free Software Foundation, Inc., 51
  Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*/

#include "E3Timestamp.h"


int main () {
  E3Timestamp t1(1, 800000000);
  E3Timestamp t2(1, 100000000);
  E3Timestamp t3(-1, 100000000);
  E3Timestamp t4(-1, 800000000);
  E3Timestamp t5(-2, 100000000);
  E3Timestamp t6(0, 100000000);
  E3Timestamp t7(0, -100000000);
  E3Timestamp t8(2, 34);
  E3Timestamp t9(1, 800000000);
  E3Timestamp t10(-2, 900000000);
  E3Timestamp t11(1, 0);
  E3Timestamp t12(0, -50);
  E3Timestamp t13(-1, 0);
  E3Timestamp t14(0, 50);
  E3Timestamp t15(1, 2100000001);
  E3Timestamp t16(-1, -2100000001);
  std::cout << "t1 = " << t1 << ", " << E3Timestamp(double(t1)) << std::endl;
  std::cout << "t2 = " << t2 << ", " << E3Timestamp(double(t2)) << std::endl;
  std::cout << "t3 = " << t3 << ", " << E3Timestamp(double(t3)) << std::endl;
  std::cout << "t4 = " << t4 << ", " << E3Timestamp(double(t4)) << std::endl;
  std::cout << "t5 = " << t5 << ", " << E3Timestamp(double(t5)) << std::endl;
  std::cout << "t6 = " << t6 << ", " << E3Timestamp(double(t6)) << std::endl;
  std::cout << "t7 = " << t7 << ", " << E3Timestamp(double(t7)) << std::endl;
  std::cout << "t8 = " << t8 << ", " << E3Timestamp(double(t8)) << std::endl;
  std::cout << "t9 = " << t9 << ", " << E3Timestamp(double(t9)) << std::endl;
  std::cout << "t10 = " << t10 << ", " << E3Timestamp(double(t10)) << std::endl;
  std::cout << "t11 = " << t11 << ", " << E3Timestamp(double(t11)) << std::endl;
  std::cout << "t12 = " << t12 << ", " << E3Timestamp(double(t12)) << std::endl;
  std::cout << "t13 = " << t13 << ", " << E3Timestamp(double(t13)) << std::endl;
  std::cout << "t14 = " << t14 << ", " << E3Timestamp(double(t14)) << std::endl;
  std::cout << "t15 = " << t15 << ", " << E3Timestamp(double(t15)) << std::endl;
  std::cout << "t16 = " << t16 << ", " << E3Timestamp(double(t16)) << std::endl;
  std::cout << "t1 > t2 -> " << (t1 > t2) << std::endl;
  std::cout << "t1 < t2 -> " << (t1 < t2) << std::endl;
  std::cout << "t1 > t3 -> " << (t1 > t3) << std::endl;
  std::cout << "t1 < t3 -> " << (t1 < t3) << std::endl;
  std::cout << "t6 < t3 -> " << (t6 < t3) << std::endl;
  std::cout << "t3 < t4 -> " << (t3 < t4) << std::endl;
  std::cout << "t3 < t6 -> " << (t3 < t6) << std::endl;
  std::cout << "t3 < t7 -> " << (t3 < t7) << std::endl;
  std::cout << "t3 == t4 -> " << (t3 == t4) << std::endl;
  std::cout << "t3 != t4 -> " << (t3 != t4) << std::endl;
  std::cout << "t1 == t9 -> " << (t1 == t9) << std::endl;
  std::cout << "t1 + t2 -> " << (t1 + t2) << std::endl;
  std::cout << "t1 + t3 -> " << (t1 + t3) << std::endl;
  std::cout << "t1 + t4 -> " << (t1 + t4) << std::endl;
  std::cout << "t1 + t5 -> " << (t1 + t5) << std::endl;
  std::cout << "t1 + t10 -> " << (t1 + t10) << std::endl;
  std::cout << "t11 + t12 -> " << (t11 + t12) << std::endl;
  std::cout << "t6 - t1 -> " << (t6 - t1) << std::endl;
  std::cout << "t6 - t2 -> " << (t6 - t2) << std::endl;
  std::cout << "t6 - t3 -> " << (t6 - t3) << std::endl;
  std::cout << "t6 - t4 -> " << (t6 - t4) << std::endl;
  std::cout << "t6 - t5 -> " << (t6 - t5) << std::endl;
  std::cout << "t4 - t5 -> " << (t4 - t5) << std::endl;
  std::cout << "t4 - t1 -> " << (t4 - t1) << std::endl;
  std::cout << "t11 - t13 -> " << (t11 - t13) << std::endl;
  std::cout << "t13 - t14 -> " << (t13 - t14) << std::endl;
  std::cout << "t14 - t13 -> " << (t14 - t13) << std::endl;
  double d1 = 179825137.195652697;
  double d2 = 179825137.195652698;
  E3Timestamp td1(d1);
  E3Timestamp td2(d2);
  std::cout << "Init from double (" << d1 << "): " << td1 << std::endl;
  std::cout << "Init from double (" << d2 << "): " << td2 << std::endl;
  std::cout << "(and if these are the same, a E3Timestamp class is necessary)"
            << std::endl;
  return 0;
}
